% Camera identification example

'Image Provenance Investigation of the Byethorne Duck - Do the four images represent the same camera that took the image 5.jpg?'
im1 = '/Users/richard/Google Drive/Active Projects/RSCPA/cropped_image1.tif',
im2 = '/Users/richard/Google Drive/Active Projects/RSCPA/cropped_image2.tif',
im3 = '/Users/richard/Google Drive/Active Projects/RSCPA/cropped_image3.tif',
im4 = '/Users/richard/Google Drive/Active Projects/RSCPA/cropped_image4.tif',
Images(1).name = im1;  Images(2).name = im2;  Images(3).name = im3;  Images(4).name = im4
RP = getFingerprint(Images);
RP = rgb2gray1(RP);
    sigmaRP = std2(RP);
Fingerprint = WienerInDFT(RP,sigmaRP);

imx = '/Users/richard/Google Drive/Active Projects/RSCPA/5right.tif',
Noisex = NoiseExtractFromImage(imx,2);
Noisex = WienerInDFT(Noisex,std2(Noisex));

% The optimal detector (see publication "Large Scale Test of Sensor Fingerprint Camera Identification")
Ix = double(rgb2gray(imread(imx)));
C = crosscorr(Noisex,Ix.*Fingerprint);
detection = PCE(C)

imx = '/Users/richard/Google Drive/Active Projects/RSCPA/5left.tif',
Noisex = NoiseExtractFromImage(imx,2);
Noisex = WienerInDFT(Noisex,std2(Noisex));

% The optimal detector (see publication "Large Scale Test of Sensor Fingerprint Camera Identification")
Ix = double(rgb2gray(imread(imx)));
C = crosscorr(Noisex,Ix.*Fingerprint);
detection = PCE(C)