
lens = imread('/Users/richard/Desktop/TempStable/RaspiOne/Lens01/TIFF/BAYER20171111-133940.tiff');
pinhole = imread('/Users/richard/Desktop/TempStable/RaspiOne/Pinhole/TIFF/BAYER20171113-132551.tiff');
lens_fingerprint = generateFingerPrint('/Users/richard/Desktop/TempStable/RaspiOne/Lens01/TIFF/BAYER20171111-133940.tiff','noSave',1);
pinhole_fingerprint = generateFingerPrint('/Users/richard/Desktop/TempStable/RaspiOne/Pinhole/TIFF/BAYER20171113-132551.tiff','noSave',1);

figure();
subplot(2,1,1)
plot(1:3280,lens(1024,:))
xlim([0,3280])
ylim([0,max(lens(1024,:))])
grid on; % optional
% Optionally add some text, a label, and a title
%xlabel('Pixel Col Number')
%ylabel('10-bit Value')
subplot(2,1,2)
plot(1:3280,100+pinhole(1024,:))
xlim([0,3280])
ylim([0,max(lens(1024,:))])
grid on; % optional
% Optionally add some text, a label, and a title
%xlabel('Pixel Col Number')
%ylabel('10-bit Value')
print('-depsc2','-r600','LensVPinholeImageLine1024.eps') % Print to file
export_fig LensVPinholeImageLine1024.eps -eps -pdf
%%%%%%%%%%


PRNUOne = generateReferencePatternNew('/Users/richard/Desktop/tempData/Pinhole/TIFF/','*.tiff','noSave',1);
DARKOne20 = generateFingerPrint('/Users/richard/Desktop/tempData/LongExposureDark45/TIFF/BAYER20180706-112357.tiff','noSave',1);
DARKOne45 = generateFingerPrint('/Users/richard/Desktop/tempData/LongExposureDark20/TIFF/BAYER20180705-192544.tiff','noSave',1);

CorrelationScores20 = [0,0,0,0];
CorrelationScores45 = [0,0,0,0];
a = imrotate(PRNUOne,0);
CorrelationScores20(1) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(1) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,90);
CorrelationScores20(2) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(2) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,180);
CorrelationScores20(3) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(3) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,270);
CorrelationScores20(4) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(4) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));

PRNUSix = generateReferencePatternNew('/Users/richard/Desktop/TempStable/RaspiSix/Pinhole/TIFF/','*.tiff','noSave',1);
DARKSix20 = generateFingerPrint('/Users/richard/ownCloud/HRD/Practicals/Stage 1/TempStable/RaspiSix/LongExposureDark45/TIFF/BAYER20180706-111435.tiff','noSave',1);
DARKSix45 = generateFingerPrint('/Users/richard/ownCloud/HRD/Practicals/Stage 1/TempStable/RaspiSix/LongExposureDark20/TIFF/BAYER20180705-193357.tiff','noSave',1);

CorrelationScoresSix20 = [0,0,0,0];
CorrelationScoresSix45 = [0,0,0,0];
a = imrotate(PRNUSix,0);
CorrelationScoresSix20(1) = getRichardCorrelate(a(384:1:,:,:),DARKSix20(,:,:));
CorrelationScoresSix45(1) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));
a = imrotate(PRNUSix,90);
CorrelationScoresSix20(2) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScoresSix45(2) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));
a = imrotate(PRNUOne,180);
CorrelationScoresSix20(3) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScoresSix45(3) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUSix,270);
CorrelationScoresSix20(4) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScoresSix45(4) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));


%%check

rotatedPRNUfirst = PRNUSix(385:1:end,:,:);
rotatedPRNUsecond = PRNUSix(1:1:384,:,:);

rotatedPRNU = cat(1,rotatedPRNUfirst,rotatedPRNUsecond);

CorrelationScores20 = [0,0,0,0];
CorrelationScores45 = [0,0,0,0];
a = imrotate(rotatedPRNU,0);
CorrelationScores20(1) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScores45(1) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));
a = imrotate(rotatedPRNU,90);
CorrelationScores20(2) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScores45(2) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));
a = imrotate(rotatedPRNU,180);
CorrelationScores20(3) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScores45(3) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));
a = imrotate(rotatedPRNU,270);
CorrelationScores20(4) = getRichardCorrelate(a(:,:,:),DARKSix20(:,:,:));
CorrelationScores45(4) = getRichardCorrelate(a(:,:,:),DARKSix45(:,:,:));





layer = 2;
figure();
subplot(1,2,1)
plot(PRNU(7,:,layer))
subplot(1,2,2)
plot(DARK(384,:,layer))
print('-depsc2','-r600','PRNUvDARK.eps') % Print to file

imagecorrelation = zeros(768,1);
for i = 1:1:767

            imagecorrelation(i,1) = getRichardCorrelate(PRNU(i:1:i+1,:,:),DARK(i:1:i+1,:,:));

end




figure();
hold 'on'
plot(abs(PRNUOne(212,1:2:end,2)))
plot(abs(DARKOne20(212,1:2:end,2)))
plot(abs(DARKOne45(212,1:2:end,2)))





PRNUOne_Gray = rgb2gray(PRNUOne);
DARKOne20_Gray = rgb2gray(DARKOne20);
DARKOne45_Gray = rgb2gray(DARKOne45);

figure();
subplot(2,1,1)
plot(xcorr(log(PRNUOne_Gray(212,:)+14)-mean(log(PRNUOne_Gray(212,:)+14)),log(DARKOne20_Gray(212,:)+14)-mean(log(DARKOne20_Gray(212,:)+14))));
subplot(2,1,2)
plot(xcorr(log(PRNUOne_Gray(212,:)+14)-mean(log(PRNUOne_Gray(212,:)+14)),log(DARKOne45_Gray(212,:)+14)-mean(log(DARKOne45_Gray(212,:)+14))));

PRNU6_Gray = rgb2gray(PRNUSix);
DARK620_Gray = rgb2gray(DARKSix20);
DARK645_Gray = rgb2gray(DARKSix45);

figure();
subplot(2,1,1)
imshow(normxcorr2(log(PRNU6_Gray(:,:)+14)-mean(log(PRNU6_Gray(212,:)+14)),log(DARK620_Gray(212,:)+14)-mean(log(DARK620_Gray(212,:)+14))));
subplot(2,1,2)
imshow(normxcorr2(log(PRNU6_Gray(:,:)+14)-mean(log(PRNU6_Gray(212,:)+14)),log(DARK645_Gray(212,:)+14)-mean(log(DARK645_Gray(212,:)+14))));



alp = log(PRNU(212,1:2:end,2)+14);
bet = log(DARK(212,1:2:end,2)+14);


figure()
PRNUplot(normxcorr2(alp-mean(alp)))

figure()
plot(xcorr2(bet-mean(bet)))

figure()
plot(abs(xcorr(alp-mean(alp),bet-mean(bet))))

figure()
plot(xcorr(PRNU_Gray(212,1:2:end),DARK_Gray(212,1:2:end)))





CorrelationScores20 = [0,0,0,0];
CorrelationScores45 = [0,0,0,0];
a = imrotate(PRNUOne,0);
CorrelationScores20(1) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(1) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,90);
CorrelationScores20(2) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(2) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,180);
CorrelationScores20(3) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(3) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));
a = imrotate(PRNUOne,270);
CorrelationScores20(4) = getRichardCorrelate(a(:,:,:),DARKOne20(:,:,:));
CorrelationScores45(4) = getRichardCorrelate(a(:,:,:),DARKOne45(:,:,:));



% correlation = zeros(1,760);
% l = 1;
% for i=1:1:760
% k = 1;
% for j=1:1:760
% a = DARK(i:i+7,j:j+7,:);
% b = PRNU(i:i+7,j:j+7,:);
% correlation(l,k) = getRichardCorrelate(a,b);
% k=k+1
% end
% l=l+1
% end

PRNU = generateFingerPrint('/Users/richard/Desktop/TempStable/RaspiOne/Pinhole/TIFF/BAYER20171113-132551.tiff','noSave',1);
DARK = generateFingerPrint('/Users/richard/ownCloud/HRD/Practicals/Stage 1/TempStable/RaspiOne/LongExposureDark45/TIFF/BAYER20180706-111458.tiff','noSave',1);

DarkMacro = DARK(192:384,384:576,:);
PRNUMacro = PRNU(192:384,384:576,:);
a = rgb2gray(PRNU(192:384,384:576,:));
b = rgb2gray(DARK(192:384,384:576,:));

CorrelationScoresMacro = [0,0,0,0];
z = imrotate(PRNUMacro,0);
CorrelationScoresMacro(1) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,90);
CorrelationScoresMacro(2) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,180);
CorrelationScoresMacro(3) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,270);
CorrelationScoresMacro(4) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));

figure();
subplot(1,3,1)
imshow(PRNUMacro(:,:,2),[min(min(DARK(:,:,layer))) max(max(PRNU(:,:,layer)))])
subplot(1,3,2)
imshow(DarkMacro(:,:,2),[min(min(DARK(:,:,layer))) max(max(PRNU(:,:,layer)))])
%%%%%

PRNUMacro = rgb2gray(PRNUMacro);
DarkMacro = rgb2gray(DarkMacro);
PRNUMacro(PRNUMacro==0) = -99;
DarkMacro(DarkMacro==0) = -99;
%%%
% for reference:
% a = rgb2gray(PRNU(192:384,384:576,:));
% b = rgb2gray(DARK(192:384,384:576,:));
%
a(a>0)=1;
b(b>0)=1;
f = PRNUMacro+DarkMacro;
f(f<0)=0;
c = and(imcomplement(a),imcomplement(b))
f=f+2.*c
subplot(1,3,3)
imshow((50.*f)./100)
print('-depsc2','-r600','PRNUvDARKwCorr.eps') % Print to file
%% GET CORRELATION FOR EACH PIXEL%%%%
%

imagecorrelation = zeros(193,193)

a = rgb2gray(PRNU(192:384,384:576,:));
b = rgb2gray(DARK(192:384,384:576,:));

for i = 1:1:193
    for j =1:1:193
            imagecorrelation(i,j) = getRichardCorrelate(a(i,j),b(i,j));
        
    end
end
c = normxcorr2(a,b);
image(c,[])

figure();
c = normxcorr2(PRNU(192:384,384:576,2),DARK(192:384,384:576,2));
imshow(c,[])


figure();
c = normxcorr2(PRNU(192:384,384:576,1),DARK(192:384,384:576,1));
imshow(c,[])


figure();
c = normxcorr2(PRNU(192:384,384:576,3),DARK(192:384,384:576,3));
figure();
imshow(log(DARK(191:2:383,383:2:575,1))+14,[])

figure();
imshow(log(PRNU(192:384,384:576,1)+14),[])

figure();
c = normxcorr2(log(PRNU(192:384,384:576,1)+14),log(DARK(192:384,384:576,1)+14));
imshow(c,[])

k = imrotate(PRNU(192:384,384:576,1),180);
getRichardCorrelate(k,DARK(192:384,384:576,1))

%% 

PRNU = generateFingerPrint('/Users/richard/Desktop/TempStable/RaspiOne/Pinhole/TIFF/BAYER20171113-132551.tiff','noSave',1);
DARK = generateFingerPrint('/Users/richard/ownCloud/HRD/Practicals/Stage 1/TempStable/RaspiOne/LongExposureDark45/TIFF/BAYER20180706-111458.tiff','noSave',1);
a = rgb2gray(PRNU);
b = rgb2gray(DARK);

DarkMacro = DARK((66*8+1-8):(66*8+1-8)+7,(37*8+1-8):(37*8+1-8)+7,:);
PRNUMacro = PRNU((66*8+1-8):(66*8+1-8)+7,(37*8+1-8):(37*8+1-8)+7,:);
a = a((66*8+1-8):(66*8+1-8)+7,(37*8+1-8):(37*8+1-8)+7);
b = b((66*8+1-8):(66*8+1-8)+7,(37*8+1-8):(37*8+1-8)+7);

CorrelationScoresMacro = [0,0,0,0];
z = imrotate(PRNUMacro,0);
CorrelationScoresMacro(1) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,90);
CorrelationScoresMacro(2) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,180);
CorrelationScoresMacro(3) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));
z = imrotate(PRNUMacro,270);
CorrelationScoresMacro(4) = getRichardCorrelate(z(:,:,:),DarkMacro(:,:,:));

figure();
subplot(1,3,1)
k = addborder(PRNUMacro, 1, [0.502,0.502,0.502], 'outer')
imshow(k)

subplot(1,3,2)
j = addborder(DarkMacro, 1, [0.502,0.502,0.502], 'outer')
imshow(j)
%%%%%
PRNUMacro = rgb2gray(PRNUMacro);
DarkMacro = rgb2gray(DarkMacro);
PRNUMacro(PRNUMacro==0) = -99;
DarkMacro(DarkMacro==0) = -99;
a(a>0)=1;
b(b>0)=1;
f = PRNUMacro+DarkMacro;
f(f<0)=0;
c = and(imcomplement(a),imcomplement(b))
f=f+2.*c
subplot(1,3,3)
f = addborder(f, 1, 1, 'outer')
imshow((50.*f)./100)
print('-depsc2','-r600','PRNUvDARKwCorrMacro.eps') % Print to file