close all;
picture=imread('Lena.jpg');
picture=picture(:,:,1); % Grab only the Red component to fake gray scaling
imshow(picture)
PQ = paddedsize(size(picture));

[X,Y]=size(picture);

D0 = 0.05*PQ(1);

D0 = (150/1136)*pi;
H = hpffilter('gaussian', PQ(1), PQ(2), D0); % Calculate the HPF
figure, imshow(fftshift(H),[]);

F=fft2(double(picture),size(H,1),size(H,2)); % Calculate the discrete Fourier transform of the image
LPF_picture=real(ifft2(H.*F)); % multiply the Fourier spectrum by the LPF and apply the inverse, discrete Fourier transform
Richard_filter=real(ifft2(H.*F))-abs(imag(ifft2(H.*F)));

HPF_picture=LPF_picture(1:size(picture,1), 1:size(picture,2)); % Resize the image to undo padding
Richard_picture = Richard_filter(1:size(picture,1), 1:size(picture,2));

figure, imshow(HPF_picture, [])
figure, imshow(Richard_picture, [])
% Display the Fourier Spectrum
Fc=fftshift(F); % move the origin of the transform to the center of the frequency rectangle
S2=log(1+abs(Fc)); % use abs to compute the magnitude (handling imaginary) and use log to brighten display
figure, imshow(S2,[])