function temperature = getEffectiveLV(picture);
%% Help
% Obtain the temperature from EXIF data for the files that are supported.
% Only 

%% Constants
% Image File Types Supported  
File_TIFF = '.tiff'; 
File_BMP = '.bmp'; 
File_JPEG = '.jpg'; 
File_CANNON2 = '.CR2'; 
File_PEF = '.PEF';

%% perform file tests
[~,fileName,fileExtension]=fileparts(picture);
fprintf('\nProcessing image: ');
fprintf(fileName);
fprintf(fileExtension);

if strcmp(fileExtension,File_TIFF)
    exitFlag=false;
elseif strcmp(fileExtension,File_BMP)
    exitFlag=false;
elseif strcmp(fileExtension,File_JPEG)
    exitFlag=false;    
elseif strcmp(fileExtension,File_CANNON2)
    exitFlag=false;    
elseif strcmp(fileExtension,File_PEF)
    exitFlag=false;
else 
    %Image File is not supported
    fprintf('\nImage File Type is currently not supported!\nContact: richard.matthews@adelaide.edu.au with example file.\n');
    exitFlag = true;
end

if exitFlag
    % do absolutely nothing as the process has not been provided with a
    % valid file type. Not your problem!
    temperature=NaN;
    fprintf('\n\nExit With Error\n');
else
    regitEXIF(picture);
    temperature = EffectiveLV;
    temperature = str2double(temperature);
end