function [patternNoise] = getPatternNoise(pictureArray,sigma_0)
%Input:
%   
%
%Output:
%   
%
% EXAMPLE
%
%   

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Written By Richard MATTHEWS
%
%   Based on Code originally written 20150317
%   Transferred to function call 20150330
%
%   Mr MATTHEWS is an academic collaborator at:
%   SCHOOL OF ELECTRICAL AND ELECTRONIC ENGINEERING
%   THE UNIVERSITY OF ADELAIDE
%   SA, AUSTRALIA 5005 
%   
%   This work was done as preliminary work for the award of MPhil in part
%   sponsered by the Australian Governemtn Department of Veterans' Affairs
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%% Mirror Pad array
paddedPictureArray = padarray(pictureArray,[8 8],'symmetric','post'); 
% Rather than determine how many 0 to pad for MAP estimate I am padding the
% maximum amount required. This differs to the previous work and may be a
% source of error.

%% perform wavelet transformation to remove low frequecy nosie
[C, l] = wavedec2(paddedPictureArray, 4,'db8');

%% call WaveNoise by Goljan
[C, ~] = WaveNoise(C,sigma_0);

%% perform inverse wavelet transformation
patternNoise = waverec2(C,l,'db8');

%% remove mirror padding
patternNoise(:,end-7:end)=[];
patternNoise(end-7:end,:)=[];

%% truncate to single.
patternNoise = single(patternNoise);

