function [correlation] =getRichardCorrelate(RP,FP)
% 
% power = sqrt(sum(sum(RP.*RP))).*sqrt(sum(sum(FP.*FP)));
% correlation=(sum(sum(RP.*FP)))./power;

[~,~,RPDim] = size(RP);
[~,~,FPDim] = size(RP);


if RPDim~=FPDim
    error('Dimension Mismatch in dimension 3');
end

if RPDim==3
 RedRP = RP(:,:,1);
 RP1 = RedRP(any(RedRP,2),any(RedRP,1));
 
 GreenRP = RP(:,:,2);
 RP2 = GreenRP(1:2:end,:);
 RP2 = RP2(any(RP2,2),any(RP2,1));
 RP3 = GreenRP(2:2:end,:);
 RP3 = RP3(any(RP3,2),any(RP3,1));   
 
 BlueRP = RP(:,:,3);
 RP4 = BlueRP(any(BlueRP,2),any(BlueRP,1));  

 RedFP = FP(:,:,1);
 FP1 = RedFP(any(RedFP,2),any(RedFP,1));
 
 GreenFP = FP(:,:,2);
 FP2 = GreenFP(1:2:end,:);
 FP2 = FP2(any(FP2,2),any(FP2,1));
 FP3 = GreenFP(2:2:end,:);
 FP3 = FP3(any(FP3,2),any(FP3,1));  
 
 BlueFP = FP(:,:,3);
 FP4 = BlueFP(any(BlueFP,2),any(BlueFP,1)); 
    
else
 RP1 = RP(1:2:end,1:2:end);
 FP1 = FP(1:2:end,1:2:end);
 
 RP2 = RP(1:2:end,2:2:end);
 FP2 = FP(1:2:end,2:2:end);
 
 RP3 = RP(2:2:end,1:2:end);
 FP3 = FP(2:2:end,1:2:end);
 
 RP4 = RP(2:2:end,2:2:end);
 FP4 = FP(2:2:end,2:2:end);
end


  
 power1 = sqrt(sum(sum(RP1.*RP1))).*sqrt(sum(sum(FP1.*FP1)));
 power2 = sqrt(sum(sum(RP2.*RP2))).*sqrt(sum(sum(FP2.*FP2)));
 power3 = sqrt(sum(sum(RP3.*RP3))).*sqrt(sum(sum(FP3.*FP3)));
 power4 = sqrt(sum(sum(RP4.*RP4))).*sqrt(sum(sum(FP4.*FP4)));
 
 correlation1=(sum(sum(RP1.*FP1)))./power1
 correlation2=(sum(sum(RP2.*FP2)))./power2
 correlation3=(sum(sum(RP3.*FP3)))./power3
 correlation4=(sum(sum(RP4.*FP4)))./power4
 
 correlation = ((correlation1+correlation2+correlation3+correlation4)/4);

% [pce1,pce0] = PCE(crosscorr(RP,FP),size(FP)-1);   % search all possible shifts
%  C = crosscorr(RP,FP); 
%  Out0 = PCE(C);
%  correlation = [pce1.PCE pce1.pvalue];
